#!/usr/bin/python
# -*-coding:Utf-8-*

# 
# TCN75A, a temperature sensor from Microchip
#
# François Septembre 2013
#


# #############################################################################
#
# Import zone
#
import errno
import os
import signal
import syslog
import sys

#import math
#from optparse import OptionParser
import string
import struct
import time
from datetime import datetime
#import datetime
from threading import Thread, Lock, Event

import socket
#from socket import socket, AF_INET, SOCK_STREAM, SHUT_RDWR
import json

# I2C management & devices
from Adafruit_I2C import Adafruit_I2C



# #############################################################################
#
# Global Variables
#

# I2C BUS
I2C_BUS=1

# I2C Base address of temp. sensor
T_SENSOR_ADDR=0x4D

# TCN75A registers
REG_TA			= 0x00	# 2 bytes signed
REG_CONFIG		= 0x01
REG_THYST		= 0x02	# 2 bytes signed
REG_TSET		= 0x03	# 2 bytes signed

#
# Function ctrlc_handler
def ctrlc_handler(signum, frame):
    stopMonitoring()

#
# Function stoping the monitoring
def stopMonitoring():
	global recs_wattmeter
	recs_wattmeter.stop()
	del recs_wattmeter
	sys.exit(1)



# #############################################################################
#
# MAIN
#

def main():

	# I2C bus initalisation (last parameter is DEBUG ==> True/False)
	tsensor = Adafruit_I2C(T_SENSOR_ADDR, I2C_BUS, True);
	
	# Configure sensor for 11 bits resolution (0.125°c) 0x40
	# Configure sensor for 10 bits resolution (0.25°c) 0x20
	cur_config = 0x20;
	err = tsensor.write8(REG_CONFIG,cur_config);
	if (err):
		print "Err = " + str(err);

	# Main loop
	while True:
		# Active open-drain mode (bit 2 in mode2 register)
		t0=datetime.now()
		cur_temp = tsensor.readList(REG_TA,2)
		t1=datetime.now()
		elapsed_time=t1 - t0
		print "Current temperature is %02d.%02d°c ... conversion took %dms\n" % (cur_temp[0], (cur_temp[1]>>6)*25, elapsed_time.microseconds/1000);
		time.sleep(1)


# Execution or import
if __name__ == "__main__":

	# Start executing
	main()


# The END - Jim Morrison 1943 - 1971
sys.exit(0)
